<script lang="ts" setup>
  import get from 'lodash/get';
  import { ParticipantState } from '~/logic/interfaces';
  import { ParticipantsControlKey } from '~/helpers/injection';

  defineProps<{
    participants: ParticipantState[];
  }>();
  const injection = inject(ParticipantsControlKey);
  const { goToClient } = useElementInteraction();
  const { streamParticipants, checkParticipantIsClient, self } = useParticipants();
  const { isGuide } = useUser();
  const { requestTokenPermission } = useCart();

  const mute = (streamId: string) => {
    window.dailyCallInstance.updateParticipant(streamId, {
      setAudio: false,
    });
  };
</script>

<template>
  <div v-if="participants.length">
    <p class="text-(information-subdued sm)">
      {{ $t('presentation.participants.inPresentation') }}
    </p>

    <div class="flex flex-col">
      <Participant
        v-for="participant of participants"
        :key="participant.videoUserId"
        active
        :participant="participant"
        :connected="Boolean(streamParticipants[participant.videoUserId])"
        :owner="get(streamParticipants[participant.videoUserId], 'data.owner')"
        :local="get(streamParticipants[participant.videoUserId], 'data.local')"
        :audio="
          get(streamParticipants[participant.videoUserId], 'data.tracks.audio.state') !== 'off'
        "
        :video="
          get(streamParticipants[participant.videoUserId], 'data.tracks.video.state') !== 'off'
        "
      >
        <template v-if="isGuide && self?.attendeeId !== participant.attendeeId" #settings>
          <template
            v-if="
              Boolean(streamParticipants[participant.videoUserId]) &&
              get(streamParticipants[participant.videoUserId], 'data.tracks.audio.state') !== 'off'
            "
          >
            <button
              class="text-(crimson-500 left) hover:bg-interactive-pressed rounded-2 px-2 py-1"
              @click="mute(participant.videoUserId)"
            >
              {{ $t('mute') }}
            </button>
            <div class="border-(information-disabled b)" />
          </template>
          <button
            v-if="checkParticipantIsClient(participant)"
            class="hover:bg-interactive-pressed rounded-2 px-2 py-1 text-left"
            @click="injection?.openStatistics(participant)"
          >
            {{ $t('presentation.participants.statistics') }}
          </button>

          <button
            class="hover:bg-interactive-pressed rounded-2 px-2 py-1 text-left"
            @click="goToClient(participant.attendeeId)"
          >
            {{ $t('presentation.participants.goToParticipant') }}
          </button>

          <button
            v-if="
              participant.guideCartPermissionsGranted &&
              !get(streamParticipants[participant.videoUserId], 'data.local') &&
              checkParticipantIsClient(participant)
            "
            class="hover:bg-interactive-pressed rounded-2 px-2 py-1 text-left"
            @click="injection?.actForUser(participant)"
          >
            {{ $t('presentation.participants.actForUser') }}
          </button>

          <button
            v-else-if="
              !participant.guideCartPermissionsGranted &&
              !get(streamParticipants[participant.videoUserId], 'data.local') &&
              checkParticipantIsClient(participant)
            "
            class="hover:bg-interactive-pressed rounded-2 px-2 py-1 text-left"
            @click="requestTokenPermission(participant.attendeeId)"
          >
            {{ $t('presentation.participants.requestPermission') }}
          </button>
        </template>
      </Participant>
    </div>
  </div>
</template>
